<?php

namespace CarDealerPress\Includes\Database;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class Truncate {

	private static $wpdb;
	public $admin_options;
	public $theme_options;
	private static $blog;

	public function __construct() {
		global $wpdb;
		self::$wpdb = $wpdb;
		self::$blog = get_current_blog_id();
	}

	public function clear_import_table() {
		self::$wpdb->query( 'TRUNCATE cdp_inventory_import_' . self::$blog );
	}

	public function cdp_inventory() {
		$query = 'TRUNCATE cdp_inventory_' . self::$blog;
		self::$wpdb->query( $query );
	}
}
