<?php

use CarDealerPress\includes\functions\Fn_Inventory;

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
echo '<html xmlns="https://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US" prefix="og: http://ogp.me/ns#">';
echo '<head>';
echo '<title>Vehicle Form Entry</title>';
echo '<script type="text/javascript" src="' . includes_url( 'js/jquery/jquery.js' ) . '"></script>';
echo '</head>';
echo '<body>';
if ( isset( $_GET['vin'] ) ) {

	$vehicle = $this->vms->get_inventory( array( 'vin' => $_GET['vin'] ) )[0];

	$price                    = ( new Fn_Inventory() )->get_price_display(
		array(
			'company' => $this->company,
			'vehicle' => $vehicle,
			'theme'   => 'from-popup',
		)
	);
	$vehicle['primary_price'] = $price['primary_price'];

	( new Fn_Inventory() )->apply_gravity_form_hooks( $vehicle );
	gravity_form( $_GET['form_id'], $display_title = false, $display_description = false, $display_inactive = false, $field_values = false, $ajax = false, $tabindex = 0, $echo = true );
}
echo '</body>';
