<?php

namespace CarDealerPress\Templates\Admin\Shortcode;

function common_params(): string {
	return <<<HTML
	<tr>
		<td class="td-full center">make</td>
		<td class="td-full center">Make Name(e . g . Dodge, Toyota, etc)</td>
		<td class="td-full center">All</td>
	</tr>
	<tr>
		<td class="td-full center">model</td>
		<td class="td-full center">Model Name(e . g . Charger, Camry, etc)</td>
		<td class="td-full center">All</td>
	</tr>
	<tr>
		<td class="td-full center">trim</td>
		<td class="td-full center">Trim Name (e.g. SE, XLE, etc)</td>
		<td class="td-full center">All</td>
	</tr>
	<tr>
		<td class="td-full center">vehicleclass</td>
		<td class="td-full center">car, truck, sport_utility, van, minivan</td>
		<td class="td-full center">All</td>
	</tr>
	<tr>
		<td class="td-full center">tag</td>
		<td class="td-full center">special, gas-saver, cherry-deal, good-buy, low-miles, one-owner, sale-pending, 
		custom-wheels, hybrid, local-trade-in, moon-roof, navigation, priced-to-go, rare, under-blue-book, wont-last *custom tags also acceptable</td>
		<td class="td-full center">empty</td>
	</tr>
HTML;
}

function short_code_parameters_headers(): string {
	return <<<HTML
	<thead>
	<th>Parameters</th>
	<th>Acceptable Values</th>
	<th>Default Value</th>
	</thead>
HTML;
}
