<?php

namespace CarDealerPress\Templates\Admin\Shortcode;

function inventory_counter() {
	$content  = <<<HTML
<div id="content-inventory-counter" class="sc-tab-content">
<div class="sc-info-header">		
<div class="sc-info-call"><span>Minimum Usage: [inventory_counter]</span></div>
<div class="sc-info-usage"><span>Example Usage: [inventory_counter saleclass="Used" show_models=0]</span></div>
</div>
<table class="sc-info-table-params">
HTML;
	$content .= short_code_parameters_headers();
	$content .= '<tbody>';
	$content .= <<<HTML
	<tr>
		<td class="td-full center">saleclass</td>
		<td class="td-full center">New, Used</td>
		<td class="td-full center">New</td>
	</tr>
	<tr> 
		<td class="td-full center">make</td>
		<td class="td-full center">Name of Make</td>
		<td class="td-full center">empty</td>
	</tr>
    <tr> 
		<td class="td-full center">model</td>
		<td class="td-full center">Name of Model</td>
		<td class="td-full center">empty</td>
	</tr>
	<tr> 
		<td class="td-full center">show_make_count</td>
		<td class="td-full center">0=Off, 1=On.</td>
		<td class="td-full center">1 (on)</td>
	</tr>
    <tr> 
		<td class="td-full center">show_models</td>
		<td class="td-full center">0=Off, 1=On.</td>
		<td class="td-full center">1 (on)</td>
	</tr>
	<tr> 
		<td class="td-full center">show_model_count</td>
		<td class="td-full center">0=Off, 1=On.</td>
		<td class="td-full center">1 (on)</td>
	</tr>
	<tr> 
		<td class="td-full center">style</td>
		<td class="td-full center">clear, counter</td>
		<td class="td-full center">counter</td>
	</tr>
</tbody>
</table>
</div>
HTML;

	return $content;
}
