<?php

namespace CarDealerPress\Templates\Admin\Shortcode;

function inventory_detail() {
	$content  = <<<HTML
<div id="content-inventory-detail" class="sc-tab-content">
<div class="sc-info-header">		
<div class="sc-info-call"><span>Minimum Usage: [inventory_detail]</span></div>
<div class="sc-info-usage"><span>Example Usage: [inventory_detail form_id=5 search=1 saleclass="Used"]</span></div>
</div>
<table class="sc-info-table-params">
HTML;
	$content .= short_code_parameters_headers();
	$content .= '<tbody>';
	$content .= <<<HTML
	<tr>
		<td class="td-full center">saleclass</td>
		<td class="td-full center">All, New, Used</td>
		<td class="td-full center">All</td>
	</tr>
HTML;
	$content .= common_params();
	$content .= <<<HTML
	<tr>
		<td class="td-full center">d_saleclass</td>
		<td class="td-full center">All,New,Used </td>
		<td class="td-full center">New<small>(only works when salecass = all)</small></td>
	</tr>
	<tr>
		<td class="td-full center">limit</td>
		<td class="td-full center">Any numeric value between 1-50</td>
		<td class="td-full center">10</td>
	</tr>
	<tr>
		<td class="td-full center">dealer_id</td>
		<td class="td-full center">Pull the inventory from another VMS ID (Useful for sites that are using an Automall ID)</td>
		<td class="td-full center">Settings ID</td>
	</tr>
	<tr>
		<td class="td-full center">form_id</td>
		<td class="td-full center">ID of Gravity Form</td>
		<td class="td-full center">0</td>
	</tr>
	<tr>
		<td class="td-full center">search</td>
		<td class="td-full center">Toggle search feature on (1) or off (0).</td>
		<td class="td-full center">0 (off)</td>
	</tr>
	<tr>
		<td class="td-full center">style</td>
		<td class="td-full center">clear</td>
		<td class="td-full center">detail</td>
	</tr>
	<tr>
		<td class="td-full center">display</td>
		<td class="td-full center">detail or razor</td>
		<td class="td-full center">detail</td>
	</tr>
	<tr>
		<td class="td-full center">fuel_type</td>
		<td class="td-full center">unleaded, hybrid, diesel</td>
		<td class="td-full center">empty</td>
	</tr>
</tbody>
</table>
</div>
HTML;

	return $content;
}
