<?php

namespace CarDealerPress\Templates\Admin\Shortcode;

function inventory_list() {
	$content  = <<<HTML
<div id="content-inventory-list" class="sc-tab-content">
<div class="sc-info-header">		
<div class="sc-info-call"><span>Minimum Usage: [inventory_list]</span></div>
<div class="sc-info-usage"><span>Example Usage: [inventory_list saleclass="Used" make ="Ford" model ="F-150"]</span></div>
</div>
<table class="sc-info-table-params">
HTML;
	$content .= short_code_parameters_headers();
	$content .= '<tbody>';
	$content .= <<<HTML
	<tr>
		<td class="td-full center">saleclass</td>
		<td class="td-full center">New, Used</td>
		<td class="td-full center">New</td>
	</tr>
HTML;
	$content .= common_params();
	$content .= <<<HTML
	<tr>
		<td class="td-full center">price_from</td>
		<td class="td-full center">Any numeric value(e . g . 1000)</td>
		<td class="td-full center">empty</td>
	</tr>
	<tr>
		<td class="td-full center">price_to</td>
		<td class="td-full center">Any numeric value(e . g . 100000)</td>
		<td class="td-full center">empty</td>
	</tr>
	<tr>
		<td class="td-full center">year_from</td>
		<td class="td-full center">Any numeric value(e . g . 1976)</td>
		<td class="td-full center">empty</td>
	</tr>
	<tr>
		<td class="td-full center">year_to</td>
		<td class="td-full center">Any numeric value(e . g . 2014)</td>
		<td class="td-full center">empty</td>
	</tr>
	<tr>
		<td class="td-full center">certified</td>
		<td class="td-full center">yes</td>
		<td class="td-full center" >empty</td>
	</tr>
	<tr>
		<td class="td-full center">limit</td>
		<td class="td-full center">Any numeric value between 1 - 50</td>
		<td class="td-full center" >10</td>
	</tr>
	<tr>
		<td class="td-full center">style</td>
		<td class="td-full center"> newspaper,newspaper_sb,clear</td>
		<td class="td-full center" >newspaper</td>
	</tr>
	<tr>
		<td class="td-full center">dealer_id</td>
		<td class="td-full center">Pull the inventory from another VMS ID(Useful for sites that are using an Automall ID)</td>
		<td class="td-full center">Settings ID</td>
	</tr>
	<tr>
		<td class="td-full center">fuel_type</td>
		<td class="td-full center">unleaded, hybrid, diesel</td>
		<td class="td-full center">empty</td>
	</tr>
	<tr>
		<td class="td-full center">use_vehicle_url</td>
		<td class="td-full center">Set to 'true' if you want to use an upstream vdp url, it will open in a new tab by default.</td>
		<td class="td-full center">false</td>
	</tr>
</tbody>
</table>
</div>
HTML;

	return $content;
}
