<?php

namespace CarDealerPress\templates\partials\admin;

use CarDealerPress\Includes\Helpers\Option;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class Display {

	public static function flamingo_theme_check(): bool {
		return 'flamingo' === strtolower(
			Option::check_for_option(
				'cdp_theme_options',
				array(
					'theme',
					'general',
					'name',
				)
			)
		);
	}
}
